"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Container = function (addChild, deleteChild, inChild) {
    if (inChild === void 0) { inChild = addChild; }
    var children = [];
    var appendChild = function (child) {
        children.push(child);
        addChild(child);
        //if (child.element) child.element.show();
    };
    var insertChild = function (child, beforeChild) {
        if (!children.includes(beforeChild)) {
            throw new Error("Relative element does not exist");
        }
        var i = children.indexOf(beforeChild);
        children.splice(i, 0, child);
        inChild(child, i, beforeChild);
        //if (child.element) child.element.show();
    };
    var removeChild = function (child) {
        if (!children.includes(child)) {
            throw new Error("Can't remove a child that's not added");
        }
        var i = children.indexOf(child);
        children.splice(i, 1);
        deleteChild(child);
    };
    return {
        appendChild: appendChild,
        insertChild: insertChild,
        removeChild: removeChild,
        children: children
    };
};
