import * as React from "react";
import * as PropTypes from "prop-types";
interface Props {
    activeOpacity: number;
    underlayColor: string;
    style: React.CSSProperties;
    onPress: () => void;
    onLongPress: () => void;
}
interface State {
    extraChildStyle: object | null;
    extraUnderlayStyle: object | null;
}
export default class TouchableHighlight extends React.Component<Props, State> {
    pressedDown: boolean;
    startedTime: number;
    state: {
        extraChildStyle: null;
        extraUnderlayStyle: null;
    };
    static defaultProps: {
        activeOpacity: number;
        underlayColor: string;
        style: {};
        onPress: () => void;
        onLongPress: () => void;
    };
    static propTypes: {
        activeOpacity: PropTypes.Requireable<number>;
        underlayColor: PropTypes.Requireable<string>;
        style: PropTypes.Requireable<object>;
        onPress: PropTypes.Requireable<(...args: any[]) => any>;
        onLongPress: PropTypes.Requireable<(...args: any[]) => any>;
    };
    onDown(): void;
    onUp(): void;
    render(): JSX.Element;
}
export {};
