"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var excluded = [
    "display",
    "top",
    "right",
    "bottom",
    "left",
    "margin",
    "marginTop",
    "marginRight",
    "marginBottom",
    "marginLeft",
    "padding",
    "paddingTop",
    "paddingRight",
    "paddingBottom",
    "paddingLeft",
    "position",
    "overflow",
    "alignItems",
    "justifyContent",
    "flexDirection",
    "flexWrap",
    "alignContent",
    "alignSelf",
    "aspectRatio",
    "flex",
    "flexBasis",
    "flexGrow",
    "flexShrink",
    "height",
    "maxHeight",
    "maxWidth",
    "minHeight",
    "minWidth",
    "width"
];
var convertToPx = ["fontSize"];
var convertStyleSheet = function (style) {
    return Object.entries(style).reduce(function (styleString, _a) {
        var propName = _a[0], propValue = _a[1];
        if (excluded.includes(propName)) {
            return styleString;
        }
        if (convertToPx.includes(propName)) {
            if (typeof propValue == "number") {
                propValue = propValue + "px";
            }
        }
        propName = propName.replace(/([A-Z])/g, function (matches) { return "-" + matches[0].toLowerCase(); });
        return "" + styleString + propName + ":" + propValue + ";";
    }, "");
};
exports.default = convertStyleSheet;
